//***************************************************************************//
//*                                                                         *//
//*         The Clip/++ User-Defined Object Extension for Clipper 5         *//
//*                UDO Command Set -- Developer's Extensions                *//
//*                                                                         *//
//*                        (c) Software Perspectives                        *//
//*                        Version 1.1   1991/07/12                         *//
//*                                                                         *//
//*           This header file is NOT to be distributed with any            *//
//*                  Class Libraries created with Clip/++.                  *//
//*                                                                         *//
//***************************************************************************//

/*
   WARNING: The following set of preprocessor commands are VERY sensitive
	    to the order they are presented in.  It is STRONGLY
	    recommended that you DO NOT edit this file in any way!
*/

#command _IV__E <n1> __D <d1> [__R <r>] [__T <t>] __TR <tr> __CB <cb> ;
    => ;
	 (__cl_av({ UPPER(<(n1)>),!<r>,<d1>,<t>,<tr>, .T., <cb>}))

#command _IV__I <n1> __D <d1> [__R <r>] [__T <t>] __TR <tr> __CB <cb> ;
    => ;
	 (__cl_av({ UPPER(<(n1)>),!<r>,<d1>,<t>,<tr>, .F., <cb>}))

#command _M__E <n> __M <m> ;
    => ;
	 (__cl_am( { UPPER(<(n)>), <m>, .T. } ))

#command _M__I <n> __M <m> ;
    => ;
	 (__cl_am( { UPPER(<(n)>), <m>, .F. } ))

#command IMPORT VARIABLES ;
	    <n1> [<c: CALCULATED BY> <cb1>] ;
	    [<t1: TYPE> \|<tp1,...>\|] ;
	    [<r: READONLY>] [<tg1: TRIGGER> <tr1>] ;
	    [,<*rest*>] ;
    => ;
	 _IV__I <n1> __D {}              ;
	    __T IF(<.t1.>,{<{tp1}>}, {}) ;
	    __R <.r.>                    ;
	    __TR {<tr1>}                 ;
	    __CB {<cb1>}                 ;
	    [; IMPORT VARIABLES <rest>]

#command EXPORT VARIABLES ;
	    <n1> [<c: CALCULATED BY> <cb1>] ;
	    [<t1: TYPE> \|<tp1,...>\|] ;
	    [<r: READONLY>] [<tg1: TRIGGER> <tr1>] ;
	    [,<*rest*>] ;
    => ;
	 _IV__E <n1> __D {}              ;
	    __T IF(<.t1.>,{<{tp1}>}, {}) ;
	    __R <.r.>                    ;
	    __TR {<tr1>}                 ;
	    __CB {<cb1>}                 ;
	    [; EXPORT VARIABLES <rest>]

#command IMPORT VARIABLES ;
	    <n1> := <v1> [<c: CALCULATED BY> <cb1>] ;
	    [<t1: TYPE> \|<tp1,...>\|] ;
	    [<r: READONLY>] [<tg1: TRIGGER> <tr1>] ;
	    [,<*rest*>] ;
    => ;
	 _IV__I <n1> __D IF( VALTYPE( <v1> )<>"B", {<{v1}>},{{||<{v1}>}});
	    __T IF(<.t1.>,{<{tp1}>}, {}) ;
	    __R <.r.>                    ;
	    __TR {<tr1>}                 ;
	    __CB {<cb1>}                 ;
	    [; IMPORT VARIABLES <rest>]

#command EXPORT VARIABLES ;
	   <n1> := <v1> [<c: CALCULATED BY> <cb1>] ;
	   [<t1: TYPE> \|<tp1,...>\|] ;
	   [<r: READONLY>] [<tg1: TRIGGER> <tr1>] ;
	   [,<*rest*>] ;
    => ;
	 _IV__E <n1> __D IF( VALTYPE( <v1> )<>"B", {<{v1}>},{{||<{v1}>}});
	    __T IF(<.t1.>,{<{tp1}>}, {}) ;
	    __R <.r.>                    ;
	    __TR {<tr1>}                 ;
	    __CB {<cb1>}                 ;
	    [; EXPORT VARIABLES <rest>]

#command IMPORT VARIABLES ;
	    <n1> = <v1> [<c: CALCULATED BY> <cb1>] ;
	    [<t1: TYPE> \|<tp1,...>\|] ;
	    [<r: READONLY>] [<tg1: TRIGGER> <tr1>] ;
	    [,<*rest*>] ;
    => ;
	 _IV__I <n1> __D IF( VALTYPE( <v1> )<>"B", {<{v1}>},{{||<{v1}>}});
	    __T IF(<.t1.>,{<{tp1}>}, {}) ;
	    __R <.r.>                    ;
	    __TR {<tr1>}                 ;
	    __CB {<cb1>}                 ;
	    [; IMPORT VARIABLES <rest>]

#command EXPORT VARIABLES ;
	    <n1> = <v1> [<c: CALCULATED BY> <cb1>] ;
	    [<t1: TYPE> \|<tp1,...>\|] ;
	    [<r: READONLY>] [<tg1: TRIGGER> <tr1>] ;
	    [,<*rest*>] ;
    => ;
	 _IV__E <n1> __D IF( VALTYPE( <v1> )<>"B", {<{v1}>},{{||<{v1}>}});
	    __T IF(<.t1.>,{<{tp1}>}, {}) ;
	    __R <.r.>                    ;
	    __TR {<tr1>}                 ;
	    __CB {<cb1>}                 ;
	    [; EXPORT VARIABLES <rest>]

#command IMPORT METHODS ;
	    <n1> := <m1> [,<*rest*>] ;
    => ;
	 _M__I <n1> __M <m1> [; IMPORT METHODS <rest>]

#command EXPORT METHODS ;
	    <n1> := <m1> [,<*rest*>] ;
    => ;
	 _M__E <n1> __M <m1> [; EXPORT METHODS <rest>]

#command IMPORT METHODS ;
	    <n1> = <m1> [,<*rest*>] ;
    => ;
	 _M__I <n1> __M <m1> [; IMPORT METHODS <rest>]

#command EXPORT METHODS ;
	    <n1> = <m1> [,<*rest*>] ;
    => ;
	 _M__E <n1> __M <m1> [; EXPORT METHODS <rest>]

#command DEFINE CLASS <c> ;
    => ;
	 __cl_dc(<(c)>,NIL,.F.)

#command DEFINE CLASS <c> INHERITING FROM <x,...> ;
    => ;
	 __cl_dc(<(c)>,{<(x)>},.F.)

#command DEFINE CLASS <c> INHERITING FROM <x,...> WITH CONFIDENCE ;
    => ;
	 __cl_dc(<(c)>,{<(x)>},.T.)

#command ENDCLASS [<d: DEBUGGABLE>] ;
    => ;
	 __cl_cc(<.d.>)

#include "Clip_Usr.ch"
