#include "Clip_Dev.ch"

/*
   Definition of the 'MenuOption' class.  Note that this class has no
   methods.  Could also easily be extended to hold more information
   about a given menu option such as color, hot key value, an expression
   to determine whether or not the option is selectable, security levels,
   etc...

   Notice how the 'Action' instance variable is declared with two types
   instead of one.  This is because it can be either of type "UDO:MENU"
   indicating a nested menu or of type "B" indicating a code block action
   to be evaluated when that menu option is selected.
*/
FUNCTION z_MenuOption

   DEFINE CLASS MenuOption
      EXPORT VARIABLES Label  TYPE |"C"|, ;
		       Action TYPE |"UDO:MENU","B"|
   ENDCLASS

RETURN NIL
